1;

function y=interp0(t,x) 
  # x = [x1, y1; x2, y2; ... xN, yN]
  # C^0 interpolation: polyline
  N = rows(x);
  if (t<x(1,1)) y = x(1,2);
  elseif (t>x(N,1)) y = x(N,2);
  else
    for ix = 2:N
      if ( t< x(ix,1)) break;  endif
    endfor
    y = (x(ix-1, 2)*(t-x(ix,1))+x(ix,2)*(x(ix-1,1)-t))/(x(ix-1,1)-x(ix,1));
#    printf("%g %g %g %g %g %g\n", x(ix-1, 1), x(ix-1, 2), x(ix, 1),x(ix, 2),
#       t, y);
  endif  
endfunction

function [r , g , b] = hsv2rgb (h,s,v)
  # h 0 360
  # s,v 0. 1.
  h;
  H = (h-floor(h / 360.)) /60. ; # 0.<= H < 6.
  i=floor(H) ; # 0...5
  f = H-i;
  p1 = v*(1.-s); p2= v*(1.-s*f); p3= v*(1.-s*(1-f));
  if     (i==0)     r= v ; g= p3; b= p1;
  elseif (i==1)     r= p2; g= v ; b= p1;
  elseif (i==2)     r= p1; g= v ; b= p3;
  elseif (i==3)     r= p1; g= p2; b= v ;
  elseif (i==4)     r= p3; g= p1; b= v ;
  else              r= v ; g= p1; b= p2;
  endif
endfunction

# the next functions build the colormaps
function cmap = rainbow_cmap(Ncc) 
  cmap = zeros (Ncc, 3);
	v=0.85;
	s=0.75;
  for i = 1:Ncc
    [cmap(i,1), cmap(i,2), cmap(i,3)] = \
    hsv2rgb((i/Ncc-0.0+(i/Ncc<0.0))*320.,s,v);
  endfor
endfunction

function cmap = topogra_cmap(Ncc) 
  cmap = zeros(Ncc, 3);
	hh = [0,250; 0.2, 250; 0.8, 30; 1., 30 ];
	ss = [0, 0.8; 0.8, 0.8;  1.,0. ];
	vv = [0, 0.65; 0.2, 0.85; 0.8, 0.55; 1., 1. ];
	for i = 1:Ncc
  	h = interp0(i/Ncc, hh); s = interp0(i/Ncc, ss); v = interp0(i/Ncc, vv);
  	[cmap(i,1), cmap(i,2), cmap(i,3)] = \
   	hsv2rgb(h,s,v);
  endfor
  cmap;
endfunction

function cmap = grays_cmap (Ncc) 
  cmap = zeros(Ncc, 3);
	for i = 1:Ncc
  	cmap(i,1) = cmap(i,2) = cmap(i,3) = (i*200/Ncc+56)/256;
	endfor
endfunction


## test
## Nmm = 100;
## mm = linspace(1,100,100);
## cmap = grays_cmap(1000);
## colormap(cmap);
## imagesc(mm,10);

